#    Mohawk Software Framework by Mohawk Software
#    Copyright (C) 1998-2001 Mark L. Woodward
# 
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Library General Public
#    License as published by the Free Software Foundation; either
#    version 2 of the License, or (at your option) any later version.
# 
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Library General Public License for more details.
# 
#    You should have received a copy of the GNU Library General Public
#    License along with this library; if not, write to the Free
#    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
#    MA 02111-1307, USA
# 
#    If you want support or to commercially license this library, the author
#    can be reached at info@mohawksoft.com


#
# Allow users to add any options to gcc
#
include $(MOHAWK_HOME)/src/options.mak

GCC=gcc -DCYGWIN -DGCC -DPOSIX $(EXTRA_GCC)
LIB=ar crs 
LINK=gcc 
LINK_DLL=gcc -shared -g 
LINK_OUT=-o
LIB_EXT=a
DLL_EXT=so
OBJ_EXT=o 
LIBNAM=libphoenix
LLIB=-l
LEXT=

#
# Base directory for PostgreSQL
#
ifdef POSTGRES
ifndef POSTGRES_HOME
POSTGRES_HOME=/usr/local/pgsql
endif
PGSQL_INC=-I$(POSTGRES_HOME)/include
PGSQL_LIB=-L$(POSTGRES_HOME)/lib  -lpq
endif

#
# debug optimizations.
#
ifndef DEBUG
CCOPT=-O3 -fexpensive-optimizations
else
CCOPT=-O1 -fexpensive-optimizations
endif

#
# Location of mohawk software headers
#
ifdef MOHAWK_HOME
LIBDIR=$(MOHAWK_HOME)/lib
BINDIR=$(MOHAWK_HOME)/bin
SRCDIR=$(MOHAWK_HOME)/src
MOHAWK_INC=-I$(MOHAWK_HOME)/src
MOHAWK_LIB=-L$(MOHAWK_HOME)/lib
endif

#
# Include and library directories.
#
DINCDIR=$(MOHAWK_INC) $(PGSQL_INC) $(EXTRA_INC)
DLIBDIR=$(MOHAWK_LIB) $(PGSQL_LIB) $(EXTRA_LIB)

ifdef TRACE
CARGS=-g $(CCOPT) -Wall -DTRACE_DEBUG
else
ifndef NDEBUG
CARGS=-g $(CCOPT) -Wall 
else
CARGS=$(CCOPT) -Wall 
endif
endif

ifdef PROFILE
CARGS+=-pg
endif

ifdef POSTGRES
CARGS+=-DPOSTGRESQL
COREOBJS+=mpgsql.o
endif
ifdef ODBC
CARGS+=-DODBC
COREOBJS+=modbcsql.o
endif

#
# The end of a compile line
#
CEND=$(DINCDIR)

CENDLIB=$(DLIBDIR) -lphoenix $(PGSQL_LIB)

%.o : %.cpp
	$(GCC) -c $(CARGS) $< $(CEND) 
% : %.cpp
	$(GCC) -o $@ $(CARGS) $(LARGS) $< $(OBJS) $(CEND) $(CENDLIB) 

%.so : %.cpp
	$(GCC) -shared -o $@ $(CARGS) $(LARGS) $< $(OBJS) $(CEND) $(CENDLIB) 
