#    Mohawk Software Framework by Mohawk Software
#    Copyright (C) 1998-2001 Mark L. Woodward
# 
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Library General Public
#    License as published by the Free Software Foundation; either
#    version 2 of the License, or (at your option) any later version.
# 
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Library General Public License for more details.
# 
#    You should have received a copy of the GNU Library General Public
#    License along with this library; if not, write to the Free
#    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
#    MA 02111-1307, USA
# 
#    If you want support or to commercially license this library, the author
#    can be reached at info@mohawksoft.com
#
# Allow users to add any options to gcc
#
include $(MOHAWK_HOME)/src/options.mak
WIN32=TRUE
MSDEV=c:/msdev/vc
WINLIBS=user32.lib gdi32.lib kernel32.lib wsock32.lib shell32.lib advapi32.lib
GCC=cl /nologo /DWIN32 /DMSC /I$(MSDEV)/include /GX /Zm200 /MT
LIB=link /lib /nologo
LINK=link /nologo 
LINK_DLL=link 
LINK_OUT=/out:
LIB_EXT=lib
DLL_EXT=dll
OBJ_EXT=obj
LIBNAM=libphoenix
EXE=.exe
LLIB=lib
LEXT=.lib
LIBODBC=odbc32.lib

#
# Base directory for PostgreSQL
#
ifdef POSTGRES
ifndef POSTGRES_HOME
POSTGRES_HOME=/cygwin/usr
endif
PGSQL_INC=-I$(POSTGRES_HOME)/include
PGSQL_LIB=/LIBPATH:$(POSTGRES_HOME)/lib  libpq.lib

endif

#
# debug optimizations.
#
ifndef DEBUG
CCOPT=-Ox
else
CCOPT=-Od
endif

#
# Location of mohawk software headers
#
ifdef MOHAWK_HOME
LIBDIR=$(MOHAWK_HOME)/lib
BINDIR=$(MOHAWK_HOME)/bin
SRCDIR=$(MOHAWK_HOME)/src
MOHAWK_INC=-I$(MOHAWK_HOME)/src
MOHAWK_LIB=/LIBPATH:$(MOHAWK_HOME)/lib
endif

#
# Include and library directories.
#
DINCDIR=$(MOHAWK_INC) $(PGSQL_INC) $(EXTRA_INC)
DLIBDIR=$(MOHAWK_LIB) $(PGSQL_LIB) $(EXTRA_LIB)

ifdef TRACE
CARGS=-Zi $(CCOPT) -DTRACE_DEBUG
else
ifndef NDEBUG
CARGS=-Zi $(CCOPT) 
else
CARGS=$(CCOPT) 
endif
endif

ifdef POSTGRES
CARGS+=-DPOSTGRESQL
COREOBJS+=mpgsql.$(OBJ_EXT)
endif
ifdef ODBC
CARGS+=-DODBC
COREOBJS+=modbcsql.$(OBJ_EXT)
endif

#
# The end of a compile line
#
CEND=$(DINCDIR)

CENDLIB=/link $(DLIBDIR) /libpath:../lib /libpath:$(MSDEV)/lib $(LIBNAM).lib $(WINLIBS) $(PGSQL_LIB)
DLLLINKLIBS= /dll $(DLIBDIR) /libpath:../lib /libpath:$(MSDEV)/lib $(LIBNAM).lib $(WINLIBS) $(PGSQL_LIB)
CENDLIBDLL=/link /out:$@ $(DLLLINKLIBS)
ENDLIBDLL= /out:$@ $(DLLLINKLIBS)

%.obj : %.cpp
	$(GCC) -c $(CARGS) $< $(CEND) 

%.exe : %.cpp
	$(GCC) $(CARGS) $< $(OBJS) $(CEND) $(CENDLIB) 

%.dll : %.cpp
	$(GCC) $(CARGS) $< $(OBJS) $(CEND) $(CENDLIBDLL) 

%.dll : %.obj
	link /out:$@ $< $(LIBOBJS) $(DLLLINKLIBS)

%.lib : %.obj
	link -lib /out:$@ $< $(LIBOBJS)


