/*
    Mohawk Software Framework by Mohawk Software
    Copyright (C) 1998-2001 Mark L. Woodward
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
 
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA
 
    If you want support or to commercially license this library, the author
    can be reached at info@mohawksoft.com
*/ 
#include "Phoenix.h"



MServerThThread::MServerThThread()
{
	m_mtx.lock();
}
MServerThThread::~MServerThThread()
{
}

void MServerThThread::threadLoop()
{
	m_mtx.lock();
	PrepSocket(&m_sock);
	m_ctStart = times(&m_tmsStart);
	HandleSocket(&m_sock);
	m_ctEnd = times(&m_tmsEnd);
	CleanUp();
	HandleSocket(&m_sock);
	m_mtx.unlock();
}

Boolean MServerThThread::Accept(MSock *ms)
{
	if(ms->Accept(&m_sock))
	{
		m_mtx.unlock();
		return TRUE;
	}
	return FALSE;
}

Boolean MThreadedServer::listen_wait()
{
	mferr.mfprintf("Can't listen on port, try again in 1 second\n");
	return TRUE;
	sleep(1);
}

class MThreadedServerThread : public MThread
{
	protected:
	MSock *			m_socklst;
	MThreadedServer *	m_tsvr;
	void threadLoop(void);
	public:
	void Run(MSock *sock, MThreadedServer *tsvr);
};

void MThreadedServerThread::threadLoop()
{
	MServerThThread *tsvr = NULL;

	while(1)
	{
		if(!tsvr)/* Create a thread structure. */
		{
			tsvr = (MServerThThread *) m_tsvr->NewThread();
			assert(tsvr);
			tsvr->run(TRUE); // Will block.

		}
		if(!tsvr->PreAccept())
		{
			delete tsvr;
			tsvr = NULL;
			continue;
		}
		if(tsvr->Accept(m_socklst))
			tsvr = NULL; // Thread will clean itself up!
	}
}

void MThreadedServerThread::Run(MSock *sock, MThreadedServer *tsvr)
{
	m_tsvr = tsvr;
	m_socklst = sock;
	run();
}

void MThreadedServer::Run(MSock *sock, int queue)
{
	MThreadedServerThread mts;

	// Loop waiting for a liste on the socket
	do
	{
		if(sock->Listen(128))
			break;

		sleep(1);

	} while(listen_wait());

	mts.Run(sock, this);

	while(1)
	{
		sleep(1);

		if(mts.status() == THSTAT_DEFUNCT)
			mts.Run(sock, this);

		if(!Pulse())
			break;
	}

}


